Index: core/roslib/src/roslib/message.py
===================================================================
--- core/roslib/src/roslib/message.py	(revision 12349)
+++ core/roslib/src/roslib/message.py	(working copy)
@@ -52,6 +52,15 @@
 # add another import to messages (which incurs higher import cost)
 struct_I = struct.Struct('<I')
 
+def isstring(s):
+    """Small helper version to check an object is a string in a way that works
+    for both Python 2 and 3
+    """
+    try:
+        return isinstance(s, basestring)
+    except NameError:
+        return isinstance(s, str)
+    
 class ROSMessageException(roslib.exceptions.ROSLibException):
     """
     Exception type for errors in roslib.message routines
@@ -162,9 +171,9 @@
     @param current_time: currently not used. Only provided for API compatibility. current_time passes in the current time with respect to the message.
     @type  current_time: Time
     """
-    if type(val) in [int, long, float, bool]:
+    if type(val) in [int, int, float, bool]:
         return str(val)
-    elif isinstance(val, basestring):
+    elif isstring(val):
         #TODO: need to escape strings correctly
         if not val:
             return "''"
@@ -230,13 +239,13 @@
     if roslib.genpy.is_simple(field_type):
         # check sign and width
         if field_type in ['byte', 'int8', 'int16', 'int32', 'int64']:
-            if type(field_val) not in [long, int]:
+            if type(field_val) not in [int, int]:
                 raise SerializationError('field %s must be an integer type'%field_name)
             maxval = int(math.pow(2, _widths[field_type]-1))
             if field_val >= maxval or field_val <= -maxval:
                 raise SerializationError('field %s exceeds specified width [%s]'%(field_name, field_type))
         elif field_type in ['char', 'uint8', 'uint16', 'uint32', 'uint64']:
-            if type(field_val) not in [long, int] or field_val < 0:
+            if type(field_val) not in [int, int] or field_val < 0:
                 raise SerializationError('field %s must be unsigned integer type'%field_name)
             maxval = int(math.pow(2, _widths[field_type]))
             if field_val >= maxval:
@@ -245,7 +254,7 @@
             if field_val not in [True, False, 0, 1]:
                 raise SerializationError('field %s is not a bool'%(field_name))
     elif field_type == 'string':
-        if type(field_val) == unicode:
+        if type(field_val) == str:
             raise SerializationError('field %s is a unicode string instead of an ascii string'%field_name)
         elif type(field_val) != str:
             raise SerializationError('field %s must be of type str'%field_name)
@@ -299,12 +308,12 @@
             raise TypeError("Message constructor may only use args OR keywords, not both")
         if args:
             if len(args) != len(self.__slots__):
-                raise TypeError, "Invalid number of arguments, args should be %s"%str(self.__slots__)+" args are"+str(args)
+                raise TypeError("Invalid number of arguments, args should be %s"%str(self.__slots__)+" args are"+str(args))
             for i, k in enumerate(self.__slots__):
                 setattr(self, k, args[i])
         else:
             # validate kwds
-            for k,v in kwds.iteritems():
+            for k,v in kwds.items():
                 if not k in self.__slots__:
                     raise AttributeError("%s is not an attribute of %s"%(k, self.__class__.__name__))
             # iterate through slots so all fields are initialized.
@@ -326,7 +335,7 @@
         """
         support for Python pickling
         """
-        for x, val in itertools.izip(self.__slots__, state):
+        for x, val in zip(self.__slots__, state):
             setattr(self, x, val)
 
     def _get_types(self):
@@ -403,9 +412,13 @@
     @return: printable representation of  msg args
     @rtype: str
     """
-    import cStringIO
+    try:
+        from cStringIO import StringIO # Python 2.x
+    except ImportError:
+        from io import StringIO # Python 3.x
+
     if buff is None:
-        buff = cStringIO.StringIO()
+        buff = StringIO()
     for f in msg.__slots__:
         if isinstance(getattr(msg, f), Message):
             get_printable_message_args(getattr(msg, f), buff=buff, prefix=(prefix+f+'.'))
@@ -432,7 +445,7 @@
                 setattr(msg, f, keys[v])
             else:
                 raise ROSMessageException("No key named [%s]"%(v))
-        elif isinstance(def_val, roslib.rostime.TVal) and type(v) in (int, long):
+        elif isinstance(def_val, roslib.rostime.TVal) and type(v) in (int, int):
             #special case to handle time value represented as a single number
             #TODO: this is a lossy conversion
             if isinstance(def_val, roslib.rostime.Time):
@@ -492,7 +505,7 @@
         #print "DICT ARGS", msg_args
         #print "ACTIVE SLOTS",msg.__slots__
         
-        for f, v in msg_args.iteritems():
+        for f, v in msg_args.items():
             # assume that an empty key is actually an empty string
             if v == None:
                 v = ''
@@ -507,7 +520,7 @@
         elif len(msg_args) < len(msg.__slots__):
             raise ROSMessageException("Not enough arguments:\n * Given: %s\n * Expected: %s"%(msg_args, msg.__slots__))
         
-        for f, v in itertools.izip(msg.__slots__, msg_args):
+        for f, v in zip(msg.__slots__, msg_args):
             _fill_val(msg, f, v, keys, prefix)
     else:
         raise ValueError("invalid msg_args type: %s"%str(msg_args))
